GIT-PULL(1)

NAME
git-pull - Pull and merge from another repository

SYNOPSIS
git-pull <options> <repository> <refspec>....sp

DESCRIPTION
Runs git-fetch with the given parameters, and calls git-merge to merge the retrieved head(s) into the current branch..sp Note that you can use . (current directory) as the <repository> to pull from the local repository — this is useful when merging local branches into the current branch..sp

OPTIONS

-n, --no-summary
    Do not show diffstat at the end of the merge.

--no-commit
    Perform the merge but pretend the merge failed and do not autocommit, to give the user a chance to inspect and further tweak the merge result before committing.

--squash
    Produce the working tree and index state as if a real merge happened, but do not actually make a commit or move the HEAD, nor record $GIT_DIR/MERGE_HEAD to cause the next git commit command to create a merge commit. This allows you to create a single commit on top of the current branch whose effect is the same as merging another branch (or more in case of an octopus).

-s <strategy>, --strategy=<strategy>
    Use the given merge strategy; can be supplied more than once to specify them in the order they should be tried. If there is no -s option, a built-in list of strategies is used instead (git-merge-recursive when merging a single head, git-merge-octopus otherwise).

-a, --append
    Append ref names and object names of fetched refs to the existing contents of will be overwritten.

--upload-pack <upload-pack>
    When given, and the repository to fetch from is handled by git-fetch-pack, --exec=<upload-pack> is passed to the command to specify non-default path for the command run on the other end.

-f, --force
    When git-fetch is used with <rbranch>:<lbranch> refspec, it refuses to update the local branch <lbranch> unless the remote branch <rbranch> it fetches is a descendant of <lbranch>. This option overrides that check.

--no-tags
    By default, git-fetch fetches tags that point at objects that are downloaded from the remote repository and stores them locally. This option disables this automatic tag following.

-t, --tags
    Most of the tags are fetched automatically as branch heads are downloaded, but tags that do not point at objects reachable from the branch heads that are being tracked will not be fetched by this mechanism. This flag lets all tags and their associated objects be downloaded.

-k, --keep
    Keep downloaded pack.

-u, --update-head-ok
    By default git-fetch refuses to update the head which corresponds to the current branch. This flag disables the check. Note that fetching into the current branch will not update the index and working directory, so use it with care.

<repository>
    The "remote" repository that is the source of a fetch or pull operation. See the section GIT URLS below.

<refspec>
    The canonical format of a <refspec> parameter is +?<src>:<dst>; that is, an optional plus +, followed by the source ref, followed by a colon :, followed by the destination ref.

    The remote ref that matches <src> is fetched, and if <dst> is not empty string, the local ref that matches it is fast forwarded using <src>. Again, if the optional plus + is used, the local ref is updated even if it does not result in a fast forward update.

    Note If the remote branch from which you want to pull is modified in non-linear ways such as being rewound and rebased frequently, then a pull will attempt a merge with an older version of itself, likely conflict, and fail. It is under these conditions that you would want to use the + sign to indicate non-fast-forward updates will be needed. There is currently no easy way to determine or declare that a branch will be made available in a repository with this behavior; the pulling user simply must know this is the expected usage pattern for a branch.

    Note You never do your own development on branches that appear on the right hand side of a <refspec> colon on Pull: lines; they are to be updated by git-fetch. If you intend to do development derived from a remote branch B, have a Pull: line to track it (i.e. Pull: B:remote-B), and have a separate branch my-B to do your development on top of it. The latter is created by git branch my-B remote-B (or its equivalent git checkout -b my-B remote-B). Run git fetch to keep track of the progress of the remote side, and when you see something new on the remote branch, merge it into your development branch with git pull . remote-B, while you are on my-B branch. The common Pull: master:origin mapping of a remote master branch to a local origin branch, which is then merged to a local development branch, again typically named master, is made when you run git clone for you to follow this pattern.

    Note There is a difference between listing multiple <refspec> directly on git-pull command line and having multiple Pull: <refspec> lines for a <repository> and running git-pull command without any explicit <refspec> parameters. <refspec> listed explicitly on the command line are always merged into the current branch after fetching. In other words, if you list more than one remote refs, you would be making an Octopus. While git-pull run without any explicit <refspec> parameter takes default <refspec>s from Pull: lines, it merges only the first <refspec> found into the current branch, after fetching all the remote refs. This is because making an Octopus from remote refs is rarely done, while keeping track of multiple remote heads in one-go by fetching more than one is often useful. Some short-cut notations are also supported.

    •   tag <tag> means the same as refs/tags/<tag>:refs/tags/<tag>; it requests fetching everything up to the given tag.

    •   A parameter <ref> without a colon is equivalent to <ref>: when pulling/fetching, so it merges <ref> into the current branch without storing the remote branch anywhere locally

GIT URLS
One of the following notations can be used to name the remote repository:.sp

•   rsync://host.xz/path/to/repo.git/

•   http://host.xz/path/to/repo.git/

•   https://host.xz/path/to/repo.git/

•   git://host.xz/path/to/repo.git/

•   git://host.xz/~user/path/to/repo.git/

•   ssh://host.xz/path/to/repo.git/

•   ssh://host.xz/~user/path/to/repo.git/

•   ssh://host.xz/~/path/to/repo.git SSH Is the default transport protocol and also supports an scp-like syntax. Both syntaxes support username expansion, as does the native git protocol. The following three are identical to the last three above, respectively:.sp

•   host.xz:/path/to/repo.git/

•   host.xz:~user/path/to/repo.git/

•   host.xz:path/to/repo.git To sync with a local directory, use:.sp

•   /path/to/repo.git/

REMOTES
In addition to the above, as a short-hand, the name of a file in $GIT_DIR/remotes directory can be given; the named file should be in the following format:.sp

    URL: one of the above URL format
    Push: <refspec>
    Pull: <refspec>
Then such a short-hand is specified in place of <repository> without <refspec> parameters on the command line, <refspec> specified on Push: lines or Pull: lines are used for git-push and git-fetch/git-pull, respectively. Multiple Push: and and Pull: lines may be specified for additional branch mappings..sp The name of a file in $GIT_DIR/branches directory can be specified as an older notation short-hand; the named file should contain a single line, a URL in one of the above formats, optionally followed by a hash # and the name of remote head (URL fragment notation). $GIT_DIR/branches/<remote> file that stores a <url> without the fragment is equivalent to have this in the corresponding file in the $GIT_DIR/remotes/ directory..sp

    URL: <url>
    Pull: refs/heads/master:<remote>
while having <url>#<head> is equivalent to.sp

    URL: <url>
    Pull: refs/heads/<head>:<remote>

MERGE STRATEGIES

resolve
    This can only resolve two heads (i.e. the current branch and another branch you pulled from) using 3-way merge algorithm. It tries to carefully detect criss-cross merge ambiguities and is considered generally safe and fast.

recursive
    This can only resolve two heads using 3-way merge algorithm. When there are more than one common ancestors that can be used for 3-way merge, it creates a merged tree of the common ancestors and uses that as the reference tree for the 3-way merge. This has been reported to result in fewer merge conflicts without causing mis-merges by tests done on actual merge commits taken from Linux 2.6 kernel development history. Additionally this can detect and handle merges involving renames. This is the default merge strategy when pulling or merging one branch.

octopus
    This resolves more than two-head case, but refuses to do complex merge that needs manual resolution. It is primarily meant to be used for bundling topic branch heads together. This is the default merge strategy when pulling or merging more than one branches.

ours
    This resolves any number of heads, but the result of the merge is always the current branch head. It is meant to be used to supersede old development history of side branches.

EXAMPLES

git pull, git pull origin
    Fetch the default head from the repository you cloned from and merge it into your current branch.

git pull -s ours . obsolete
    Merge local branch obsolete into the current branch, using ours merge strategy.

git pull . fixes enhancements
    Bundle local branch fixes and enhancements on top of the current branch, making an Octopus merge.

git pull --no-commit . maint
    Merge local branch maint into the current branch, but do not make a commit automatically. This can be used when you want to include further changes to the merge, or want to write your own merge commit message.

    You should refrain from abusing this option to sneak substantial changes into a merge commit. Small fixups like bumping release/version name would be acceptable.

Command line pull of multiple branches from one repository

    $ cat .git/remotes/origin
    URL: git://git.kernel.org/pub/scm/git/git.git
    Pull: master:origin
    $ git checkout master
    $ git fetch origin master:origin +pu:pu maint:maint
    $ git pull . origin
Here, a typical file from a git-clone operation is used in combination with command line options to git-fetch to first update multiple branches of the local repository and then to merge the remote origin branch into the local master branch. The local pu branch is updated even if it does not result in a fast forward update. Here, the pull can obtain its objects from the local repository using git-fetch is known to have already obtained and made available all the necessary objects.

Pull of multiple branches from one repository using .git/remotes file

    $ cat .git/remotes/origin
    URL: git://git.kernel.org/pub/scm/git/git.git
    Pull: master:origin
    Pull: +pu:pu
    Pull: maint:maint
    $ git checkout master
    $ git pull origin
Here, a typical file from a git-clone operation has been hand-modified to include the branch-mapping of additional remote and local heads directly. A single git-pull operation while in the master branch will fetch multiple heads and merge the remote origin head into the current, local master branch. If you tried a pull which resulted in a complex conflicts and would want to start over, you can recover with git-reset(1)..sp

SEE ALSO
git-fetch(1), git-merge(1).sp

AUTHOR
Written by Linus Torvalds <torvalds@osdl.org> and Junio C Hamano <junkio@cox.net>.sp

DOCUMENTATION
Documentation by Jon Loeliger, David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>..sp

GIT
Part of the git(7) suite.sp